package Mailtrace::System::Basic;

# Includes
use strict;
use warnings;
use Time::HiRes qw( gettimeofday );
use Digest::MD5 qw( md5_hex );

# Constructor
sub new {
	my ($invocant) = @_;
	
	# Was the constructor called by an instance or an class?
	my $class = ref($invocant) || $invocant;
	
	# Instance is a hash reference
	my $self = {};
	
	# Make hashreference to an instance
	bless ($self, $class); 
	
	# Return the instance
    return $self
}

# Set debug object variable to one
sub activateDebug {
	my ($self) = @_;
	$self->{'Debug'} = 1;
	return 1;
}

sub alert {
	my ($self, $exitCode, $message) = @_;

    my $time = $self->now();
    for (split(/\n/, $message)) {
        chomp;
        print $time."  ALERT for PID ".$$.": $_\n";
    }

    $self->end($exitCode) if defined $exitCode;
    
    return 1;
}

sub end {
    my ($self, $exit) = @_;
	
    exit $exit if defined $exit;
    exit 0;
}

# Example: 2008-09-16 15:04:27
sub now {
	my ($self) = @_;
    my @now = localtime;
    return sprintf("%d-%02d-%02d %02d:%02d:%02d",$now[5]+1900,$now[4]+1,$now[3],$now[2],$now[1],$now[0]);
}

1;

__END__